////////////////////////////////////////////////////////
//  Bouncy Rockets Mutator - Written by MavisPuford 2008
////////////////////////////////////////////////////////

class BouncyRockets extends UTMutator
      config(BouncyRockets);

var config float BouncyLifeSpan;
var config float BouncySpeed;
var config float BouncyAcceleration;
var config bool BouncySpawnWithGun;
var config bool BouncyReplaceAllWeapons;
var config bool BouncyExplodeIfNearBy;
var config bool BouncyPlayImpactSound;

function InitMutator(string Options, out string ErrorMessage)
{
if (UTGame(WorldInfo.Game) != None && BouncySpawnWithGun == true)
   {
   //Makes the player spawn with the Bouncy Rocket Launcher in hand
   UTGame(WorldInfo.Game).DefaultInventory[0] = class'BouncyRockets.UTWeap_BouncyRocketLauncher';
   }

Super.InitMutator(Options, ErrorMessage);
}

function bool CheckReplacement(Actor Other)
{
	local UTWeaponPickupFactory WeaponPickup;
    local UTAmmoPickupFactory AmmoPickup;
//	local UTWeaponLocker Locker;

if (Other.IsA('UTWeap_RocketLauncher') && !Other.IsA('UTWeap_BouncyRocketLauncher'))
{
   ReplaceWith(Other, "UTWeap_BouncyRocketLauncher");
}

//Replaces the Weapon Pickups with the Bouncy Rocket Launcher
WeaponPickup = UTWeaponPickupFactory(Other);
if (WeaponPickup != None)
{
    if (WeaponPickup.WeaponPickupClass != None && BouncyReplaceAllWeapons == true)
    {
        WeaponPickup.WeaponPickupClass = class'BouncyRockets.UTWeap_BouncyRocketLauncher';
        WeaponPickup.InitializePickup();
    }
    else if (WeaponPickup.WeaponPickupClass == class'UTWeap_RocketLauncher' && WeaponPickup.WeaponPickupClass != class'UTWeap_BouncyRocketLauncher')
    {
        WeaponPickup.WeaponPickupClass = class'BouncyRockets.UTWeap_BouncyRocketLauncher';
        WeaponPickup.InitializePickup();
    }
}
else
{
    AmmoPickup = UTAmmoPickupFactory(Other);
    if (AmmoPickup != None && BouncyReplaceAllWeapons == true)
    {
        //Replaces all ammo with rocket packs
        AmmoPickup.TransformAmmoType(class'UTAmmo_RocketLauncher');
        AmmoPickup = AmmoPickup.Spawn(class'UTAmmo_RocketLauncher');
    }
}







return true;
}

DefaultProperties
{
}