class UTProj_BouncyRocket extends UTProj_Rocket
      config(BouncyRockets);

var float BounceAcceleration;



function PreBeginPlay()
{
    super.PreBeginPlay();

    speed = class'BouncyRockets'.default.BouncySpeed;
    LifeSpan = class'BouncyRockets'.default.BouncyLifeSpan;
    BounceAcceleration = class'BouncyRockets'.default.BouncyAcceleration;
}

replication {
       if ( Role == ROLE_Authority )
          BounceAcceleration;
}

//This event prevents rockets from exploding and makes them bounce when they hit a wall
simulated event HitWall(vector HitNormal, Actor Wall, PrimitiveComponent WallComp)
{
	bBlockedByInstigator = true;

	if ( WorldInfo.NetMode != NM_DedicatedServer && class'BouncyRockets'.default.BouncyPlayImpactSound == true)
	{
		PlaySound(ImpactSound, true);
	}

	// check to make sure we didn't hit a pawn


	if ( Pawn(Wall) == none )
	{
        //Change of Velocity and rotation on impact
        if (VSize(Velocity) < maxspeed)  // Reflect off Wall - Increase/Decrease speed
        {
              Velocity = BounceAcceleration * (( Velocity dot HitNormal ) * HitNormal * -2.0 + Velocity);
              Speed = VSize(Velocity);
        } else                           // Reflect off Wall - Speed is maxed out
        {
              Velocity = (( Velocity dot HitNormal ) * HitNormal * -2.0 + Velocity);
              Speed = maxspeed;
        }
        SetRotation(rotator(Velocity));

        //Makes the rockets explode if they bounce within the damage radius of a Pawn
        if (class'BouncyRockets'.default.BouncyExplodeIfNearBy == true)
        foreach VisibleCollidingActors(class'Actor', Wall, DamageRadius, Location)
        {
        if (Pawn(Wall) != none)
           Explode(Location, HitNormal);
        else continue;
        }

		// If we hit a pawn or we are moving too slowly, explode
		if ( Speed < 50 || Pawn(Wall) != none )
		{
            Explode(Location, HitNormal);
            /*
			ImpactedActor = Wall;
			SetPhysics(PHYS_None);
			if (ProjEffects!=None)
			{
				ProjEffects.DeactivateSystem();
			}
            */
		}
	}
	else if ( Wall != Instigator ) 	// Hit a different pawn, just explode
	{
		Explode(Location, HitNormal);
	}

}

DefaultProperties
{
      maxspeed=5000.000
      MomentumTransfer=85000.000000
      ImpactSound=SoundCue'A_Weapon_RocketLauncher.Cue.A_Weapon_RL_GrenadeFloor_Cue'
}