class UTProj_SeekingBouncyRocket extends UTProj_SeekingRocket config (MutBouncyRockets)
      config(BouncyRockets);

function PreBeginPlay()
{
super.PreBeginPlay();

maxspeed = class'BouncyRockets'.default.BouncySpeed;
speed = class'BouncyRockets'.default.BouncySpeed;
LifeSpan = class'BouncyRockets'.default.BouncyLifeSpan;
}

/*
simulated function PostBeginPlay()
{
    LifeSpan = BouncyLifeSpan;
    Speed = BouncySpeed;
	Super.PostBeginPlay();
}
*/

simulated event HitWall(vector HitNormal, Actor Wall, PrimitiveComponent WallComp)
{
	bBlockedByInstigator = true;

	if ( WorldInfo.NetMode != NM_DedicatedServer )
	{
		PlaySound(ImpactSound, true);
	}

	// check to make sure we didn't hit a pawn

	if ( Pawn(Wall) == none )
	{
        //Change of Velocity and rotation on impact
		Velocity = /*0.75**/(( Velocity dot HitNormal ) * HitNormal * -2.0 + Velocity);   // Reflect off Wall w/damping
		Speed = VSize(Velocity);
		SetRotation(rotator(Velocity));

		// If we hit a pawn or we are moving too slowly, explode

		if ( Speed < 20 || Pawn(Wall) != none )
		{
			ImpactedActor = Wall;
			SetPhysics(PHYS_None);
			if (ProjEffects!=None)
			{
				ProjEffects.DeactivateSystem();
			}
		}
	}
	else if ( Wall != Instigator ) 	// Hit a different pawn, just explode
	{
		Explode(Location, HitNormal);
	}
}

DefaultProperties
{
    Speed=1350.000
    LifeSpan=1350.000
    MomentumTransfer=85000.000000
}