class UTUIFrontEnd_BouncyRocketsMenu extends UTUIFrontEnd;

var transient UTUISlider RocketLifeSpan;
var transient UTUISlider RocketSpeed;
var transient UTUISlider RocketBounceAcceleration;
var transient UTUICollectionCheckBox RocketSpawnWithGun;
var transient UTUICollectionCheckBox RocketReplaceAllWeapons;
var transient UTUICollectionCheckBox RocketExplodeIfNearBy;
var transient UTUICollectionCheckBox RocketPlayImpactSound;

event SceneActivated(bool bInitialActivation)
{
    Super.SceneActivated(bInitialActivation);

    if (bInitialActivation)
    {
        RocketLifeSpan = UTUISlider(FindChild('sliLifeSpan', true));
        RocketSpeed = UTUISlider(FindChild('sliSpeed', true));
        RocketBounceAcceleration = UTUISlider(FindChild('sliBounceAcceleration', true));
        RocketSpawnWithGun = UTUICollectionCheckBox(FindChild('boxSpawnWithGun', true));
        RocketReplaceAllWeapons = UTUICollectionCheckBox(FindChild('boxReplaceAllWeapons', true));
        RocketExplodeIfNearBy = UTUICollectionCheckBox(FindChild('boxExplodeIfNearBy', true));
        RocketPlayImpactSound = UTUICollectionCheckBox(FindChild('boxPlayImpactSound', true));

        RocketLifeSpan.SliderValue.CurrentValue = 8.f;
        RocketLifeSpan.SliderValue.MinValue = 1.f;
        RocketLifeSpan.SliderValue.MaxValue = 50.f;
        RocketLifeSpan.SliderValue.NudgeValue = 1.f;
        RocketLifeSpan.SliderValue.bIntRange = true;

        RocketSpeed.SliderValue.CurrentValue = 1350.0.f;
        RocketSpeed.SliderValue.MinValue = 100.0.f;
        RocketSpeed.SliderValue.MaxValue = 5000.0.f;
        RocketSpeed.SliderValue.NudgeValue = 50.0.f;
        RocketSpeed.SliderValue.bIntRange = true;

        RocketBounceAcceleration.SliderValue.CurrentValue = 100.0.f;
        RocketBounceAcceleration.SliderValue.MinValue = 50.0.f;
        RocketBounceAcceleration.SliderValue.MaxValue = 150.0.f;
        RocketBounceAcceleration.SliderValue.NudgeValue = 25.0.f;
        RocketBounceAcceleration.SliderValue.bIntRange = true;

        RocketSpawnWithGun.SetValue(true);
        RocketReplaceAllWeapons.SetValue(false);
        RocketExplodeIfNearBy.SetValue(true);
        RocketPlayImpactSound.SetValue(true);
    }
}

function SetupButtonBar()
{
ButtonBar.Clear();
ButtonBar.AppendButton("<Strings:UTGameUI.ButtonCallouts.Accept>", OnButtonBar_Accept);
ButtonBar.AppendButton("<Strings:UTGameUI.ButtonCallouts.Back>", OnButtonBar_Back);
}

event PostInitialize()
{
    Super.PostInitialize();

    RocketLifeSpan.UpdateCaption();
    RocketSpeed.UpdateCaption();
    RocketBounceAcceleration.UpdateCaption();
}

function bool OnButtonBar_Accept(UIScreenObject InButton, int InPlayerIndex)
{
    class'BouncyRockets.BouncyRockets'.default.BouncyLifeSpan = RocketLifeSpan.GetValue();
    class'BouncyRockets.BouncyRockets'.default.BouncySpeed = RocketSpeed.GetValue();
    class'BouncyRockets.BouncyRockets'.default.BouncyAcceleration = (0.01 * RocketBounceAcceleration.GetValue());
    class'BouncyRockets.BouncyRockets'.default.BouncySpawnWithGun = RocketSpawnWithGun.IsChecked();
    class'BouncyRockets.BouncyRockets'.default.BouncyReplaceAllWeapons = RocketReplaceAllWeapons.IsChecked();
    class'BouncyRockets.BouncyRockets'.default.BouncyExplodeIfNearBy = RocketExplodeIfNearBy.IsChecked();
    class'BouncyRockets.BouncyRockets'.default.BouncyPlayImpactSound = RocketPlayImpactSound.IsChecked();

    class'BouncyRockets.BouncyRockets'.static.StaticSaveConfig();

    CloseScene(self);

    return true;
}

function bool OnButtonBar_Back(UIScreenObject InButton, int InPlayerIndex)
{
    CloseScene(self);

    return true;
}

DefaultProperties
{
   Name="Default__UTUIFrontEnd_BouncyRocketsMenu"
}